
uniform sampler2DRect tex;

uniform float gamma;
uniform float a;
uniform float b;
uniform float c;
uniform float d;


#define Rec709GammaEncode(x)		mix(1.099 * pow(x, vec3(0.45)) - 0.099,  4.5 * x,  vec3(lessThan(x, vec3(0.018))))
#define ParametricGammaDecode(x)	mix(x * c, pow(a * x + b, vec3(gamma)), vec3(greaterThanEqual(x, vec3(d))))

void main()
{
	vec4 color0 = texture2DRect(tex, gl_TexCoord[0].st);
	gl_FragColor = vec4(Rec709GammaEncode(ParametricGammaDecode(color0.rgb)), 1.0);
}


//	float ParametricGammaDecode(float x)
//	{
//		if (x >= d) {
//			return pow(a * x + b, gamma);
//		}
//		
//		return c * x;
//	}
//	
//	
//	float Rec709GammaEncode(float x)
//	{
//		if (x < 0.018) {
//			return 4.5 * x;
//		}
//		
//		return 1.099 * pow(x, 0.45) - 0.099;
//	}
//
//
//	 
//	void main()
//	{
//		vec4 color0 = texture2DRect(tex, gl_TexCoord[0].st);
//		
//		gl_FragColor = vec4(Rec709GammaEncode( ParametricGammaDecode(color0.r) ),
//							Rec709GammaEncode( ParametricGammaDecode(color0.g) ),
//							Rec709GammaEncode( ParametricGammaDecode(color0.b) ),
//							1.0);
//	}
